## GtkScrolledWindow GtkScrolledWindow |

## Functions

GtkWidget * | gtk_scrolled_window_new ()
GtkAdjustment * | gtk_scrolled_window_get_hadjustment ()
GtkAdjustment * | gtk_scrolled_window_get_vadjustment ()
GtkWidget * | gtk_scrolled_window_get_hscrollbar ()
GtkWidget * | gtk_scrolled_window_get_vscrollbar ()
void | gtk_scrolled_window_set_policy ()
void | gtk_scrolled_window_add_with_viewport ()
void | gtk_scrolled_window_set_placement ()
void | gtk_scrolled_window_unset_placement ()
void | gtk_scrolled_window_set_shadow_type ()
void | gtk_scrolled_window_set_hadjustment ()
void | gtk_scrolled_window_set_vadjustment ()
GtkCornerType | gtk_scrolled_window_get_placement ()
void | gtk_scrolled_window_get_policy ()
GtkShadowType | gtk_scrolled_window_get_shadow_type ()

## Properties

GtkAdjustment * | hadjustment | Read / Write / Construct
GtkPolicyType | hscrollbar-policy | Read / Write
GtkShadowType | shadow-type | Read / Write
GtkAdjustment * | vadjustment | Read / Write / Construct
GtkPolicyType | vscrollbar-policy | Read / Write
GtkCornerType | window-placement | Read / Write
gboolean | window-placement-set | Read / Write

## Style Properties

int | scrollbar-spacing | Read
gboolean | scrollbars-within-bevel | Read

## Signals

void | move-focus-out | Action
gboolean | scroll-child | Action

## Types and Values

struct | GtkScrolledWindow

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkObject
                ╰── GtkWidget
                    ╰── GtkContainer
                        ╰── GtkBin
                            ╰── GtkScrolledWindow

## Implemented Interfaces

GtkScrolledWindow implements AtkImplementorIface and GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

## Functions

### gtk_scrolled_window_new ()

    GtkWidget *
    gtk_scrolled_window_new (GtkAdjustment *hadjustment,
                             GtkAdjustment *vadjustment);

Creates a new scrolled window.

The two arguments are the scrolled window's adjustments; these will be shared with the scrollbars and the child widget to keep the bars in sync with the child. Usually you want to pass `NULL` for the adjustments, which will cause the scrolled window to create them for you.

#### Parameters

hadjustment | horizontal adjustment. | [allow-none]
vadjustment | vertical adjustment. | [allow-none]

#### Returns

a new scrolled window

### gtk_scrolled_window_get_hadjustment ()

    GtkAdjustment *
    gtk_scrolled_window_get_hadjustment (GtkScrolledWindow *scrolled_window);

Returns the horizontal scrollbar's adjustment, used to connect the horizontal scrollbar to the child widget's horizontal scroll functionality.

#### Parameters

scrolled_window | a GtkScrolledWindow |

#### Returns

the horizontal GtkAdjustment.

[transfer none]

### gtk_scrolled_window_get_vadjustment ()

    GtkAdjustment *
    gtk_scrolled_window_get_vadjustment (GtkScrolledWindow *scrolled_window);

Returns the vertical scrollbar's adjustment, used to connect the vertical scrollbar to the child widget's vertical scroll functionality.

#### Parameters

scrolled_window | a GtkScrolledWindow |

#### Returns

the vertical GtkAdjustment.

[transfer none]

### gtk_scrolled_window_get_hscrollbar ()

    GtkWidget *
    gtk_scrolled_window_get_hscrollbar (GtkScrolledWindow *scrolled_window);

Returns the horizontal scrollbar of `scrolled_window` .

#### Parameters

scrolled_window | a GtkScrolledWindow |

#### Returns

the horizontal scrollbar of the scrolled window, or `NULL` if it does not have one.

[transfer none]

Since: 2.8

### gtk_scrolled_window_get_vscrollbar ()

    GtkWidget *
    gtk_scrolled_window_get_vscrollbar (GtkScrolledWindow *scrolled_window);

Returns the vertical scrollbar of `scrolled_window` .

#### Parameters

scrolled_window | a GtkScrolledWindow |

#### Returns

the vertical scrollbar of the scrolled window, or `NULL` if it does not have one.

[transfer none]

Since: 2.8

### gtk_scrolled_window_set_policy ()

    void
    gtk_scrolled_window_set_policy (GtkScrolledWindow *scrolled_window,
                                    GtkPolicyType hscrollbar_policy,
                                    GtkPolicyType vscrollbar_policy);

Sets the scrollbar policy for the horizontal and vertical scrollbars.

The policy determines when the scrollbar should appear; it is a value from the GtkPolicyType enumeration. If `GTK_POLICY_ALWAYS`, the scrollbar is always present; if `GTK_POLICY_NEVER`, the scrollbar is never present; if `GTK_POLICY_AUTOMATIC`, the scrollbar is present only if needed (that is, if the slider part of the bar would be smaller than the trough - the display is larger than the page size).

#### Parameters

scrolled_window | a GtkScrolledWindow |
hscrollbar_policy | policy for horizontal bar |
vscrollbar_policy | policy for vertical bar |

### gtk_scrolled_window_add_with_viewport ()

    void
    gtk_scrolled_window_add_with_viewport (GtkScrolledWindow *scrolled_window,
                                           GtkWidget *child);

Used to add children without native scrolling capabilities. This is simply a convenience function; it is equivalent to adding the unscrollable child to a viewport, then adding the viewport to the scrolled window. If a child has native scrolling, use `gtk_container_add()` instead of this function.

The viewport scrolls the child by moving its GdkWindow, and takes the size of the child to be the size of its toplevel GdkWindow. This will be very wrong for most widgets that support native scrolling; for example, if you add a widget such as GtkTreeView with a viewport, the whole widget will scroll, including the column headings. Thus, widgets with native scrolling support should not be used with the GtkViewport proxy.

A widget supports scrolling natively if the set_scroll_adjustments_signal field in GtkWidgetClass is non-zero, i.e. has been filled in with a valid signal identifier.

#### Parameters

scrolled_window | a GtkScrolledWindow |
child | the widget you want to scroll |

### gtk_scrolled_window_set_placement ()

    void
    gtk_scrolled_window_set_placement (GtkScrolledWindow *scrolled_window,
                                       GtkCornerType window_placement);

Sets the placement of the contents with respect to the scrollbars for the scrolled window.

The default is `GTK_CORNER_TOP_LEFT`, meaning the child is in the top left, with the scrollbars underneath and to the right. Other values in GtkCornerType are `GTK_CORNER_TOP_RIGHT`, `GTK_CORNER_BOTTOM_LEFT`, and `GTK_CORNER_BOTTOM_RIGHT`.

See also `gtk_scrolled_window_get_placement()` and `gtk_scrolled_window_unset_placement()`.

#### Parameters

scrolled_window | a GtkScrolledWindow |
window_placement | position of the child window |

### gtk_scrolled_window_unset_placement ()

    void
    gtk_scrolled_window_unset_placement (GtkScrolledWindow *scrolled_window);

Unsets the placement of the contents with respect to the scrollbars for the scrolled window. If no window placement is set for a scrolled window, it obeys the "gtk-scrolled-window-placement" XSETTING.

See also `gtk_scrolled_window_set_placement()` and `gtk_scrolled_window_get_placement()`.

#### Parameters

scrolled_window | a GtkScrolledWindow |

Since: 2.10

### gtk_scrolled_window_set_shadow_type ()

    void
    gtk_scrolled_window_set_shadow_type (GtkScrolledWindow *scrolled_window,
                                         GtkShadowType type);

Changes the type of shadow drawn around the contents of `scrolled_window` .

#### Parameters

scrolled_window | a GtkScrolledWindow |
type | kind of shadow to draw around scrolled window contents |

### gtk_scrolled_window_set_hadjustment ()

    void
    gtk_scrolled_window_set_hadjustment (GtkScrolledWindow *scrolled_window,
                                         GtkAdjustment *hadjustment);

Sets the GtkAdjustment for the horizontal scrollbar.

#### Parameters

scrolled_window | a GtkScrolledWindow |
hadjustment | horizontal scroll adjustment |

### gtk_scrolled_window_set_vadjustment ()

    void
    gtk_scrolled_window_set_vadjustment (GtkScrolledWindow *scrolled_window,
                                         GtkAdjustment *vadjustment);

Sets the GtkAdjustment for the vertical scrollbar.

#### Parameters

scrolled_window | a GtkScrolledWindow |
vadjustment | vertical scroll adjustment |

### gtk_scrolled_window_get_placement ()

    GtkCornerType
    gtk_scrolled_window_get_placement (GtkScrolledWindow *scrolled_window);

Gets the placement of the contents with respect to the scrollbars for the scrolled window. See `gtk_scrolled_window_set_placement()`.

#### Parameters

scrolled_window | a GtkScrolledWindow |

#### Returns

the current placement value.

See also `gtk_scrolled_window_set_placement()` and `gtk_scrolled_window_unset_placement()`.

### gtk_scrolled_window_get_policy ()

    void
    gtk_scrolled_window_get_policy (GtkScrolledWindow *scrolled_window,
                                    GtkPolicyType *hscrollbar_policy,
                                    GtkPolicyType *vscrollbar_policy);

Retrieves the current policy values for the horizontal and vertical scrollbars. See `gtk_scrolled_window_set_policy()`.

#### Parameters

scrolled_window | a GtkScrolledWindow |
hscrollbar_policy | location to store the policy for the horizontal scrollbar, or `NULL`. | [out][allow-none]
vscrollbar_policy | location to store the policy for the vertical scrollbar, or `NULL`. | [out][allow-none]

### gtk_scrolled_window_get_shadow_type ()

    GtkShadowType
    gtk_scrolled_window_get_shadow_type (GtkScrolledWindow *scrolled_window);

Gets the shadow type of the scrolled window. See `gtk_scrolled_window_set_shadow_type()`.

#### Parameters

scrolled_window | a GtkScrolledWindow |

#### Returns

the current shadow type

## Types and Values

### struct GtkScrolledWindow

    struct GtkScrolledWindow {
      GtkWidget *GSEAL (hscrollbar);
      GtkWidget *GSEAL (vscrollbar);
    };

## Property Details

### The `“hadjustment”` property

      “hadjustment”              GtkAdjustment *

The GtkAdjustment for the horizontal position.

Owner: GtkScrolledWindow

Flags: Read / Write / Construct

### The `“hscrollbar-policy”` property

      “hscrollbar-policy”        GtkPolicyType

When the horizontal scrollbar is displayed.

Owner: GtkScrolledWindow

Flags: Read / Write

Default value: GTK_POLICY_ALWAYS

### The `“shadow-type”` property

      “shadow-type”              GtkShadowType

Style of bevel around the contents.

Owner: GtkScrolledWindow

Flags: Read / Write

Default value: GTK_SHADOW_NONE

### The `“vadjustment”` property

      “vadjustment”              GtkAdjustment *

The GtkAdjustment for the vertical position.

Owner: GtkScrolledWindow

Flags: Read / Write / Construct

### The `“vscrollbar-policy”` property

      “vscrollbar-policy”        GtkPolicyType

When the vertical scrollbar is displayed.

Owner: GtkScrolledWindow

Flags: Read / Write

Default value: GTK_POLICY_ALWAYS

### The `“window-placement”` property

      “window-placement”         GtkCornerType

Where the contents are located with respect to the scrollbars. This property only takes effect if "window-placement-set" is TRUE.

Owner: GtkScrolledWindow

Flags: Read / Write

Default value: GTK_CORNER_TOP_LEFT

### The `“window-placement-set”` property

      “window-placement-set”     gboolean

Whether "window-placement" should be used to determine the location of the contents with respect to the scrollbars. Otherwise, the "gtk-scrolled-window-placement" setting is used.

Owner: GtkScrolledWindow

Flags: Read / Write

Default value: FALSE

Since: 2.10

## Style Property Details

### The `“scrollbar-spacing”` style property

      “scrollbar-spacing”        int

Number of pixels between the scrollbars and the scrolled window.

Owner: GtkScrolledWindow

Flags: Read

Allowed values: >= 0

Default value: 3

### The `“scrollbars-within-bevel”` style property

      “scrollbars-within-bevel”  gboolean

Whether to place scrollbars within the scrolled window's bevel.

Owner: GtkScrolledWindow

Flags: Read

Default value: FALSE

Since: 2.12

## Signal Details

### The `“move-focus-out”` signal

    void
    user_function (GtkScrolledWindow *scrolledwindow,
                   GtkDirectionType   arg1,
                   gpointer           user_data)

Flags: Action

### The `“scroll-child”` signal

    gboolean
    user_function (GtkScrolledWindow *scrolled_window,
                   GtkScrollType      scroll,
                   gboolean           horizontal,
                   gpointer           user_data)

The ::scroll-child signal is a

keybinding signal

which gets emitted when a keybinding that scrolls is pressed. The horizontal or vertical adjustment is updated which triggers a signal that the scrolled windows child may listen to and scroll itself.

#### Parameters

scrolled_window | a GtkScrolledWindow |
scroll | a GtkScrollType describing how much to scroll |
horizontal | whether the keybinding scrolls the child horizontally or not |
user_data | user data set when the signal handler was connected. |

Flags: Action